<?php
class Bio_Entrez_eFetch
{
	/**
	 * Az Entrez eSearch szolgáltatásának elérési útvonala
	 * @var string
	 */
	private static $eFetchURL 	= 'http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?';

	/**
	 * A lekérdezés formátuma
	 * @var string
	 */
	private $retriveMode		= 'xml';
	private $retriveType		= 'gb'; // GenBank

	private $database;
	private $id;

	/**
	 * @param string $database A találatot tartalmazó adatbázis neve (pl.: 'nuccore')
	 * @param integer $id A találat Entrez azonosítója
	 */
	public function __construct($database, $id)

	/**
	 * A lekérdezés végrehajtása
	 * @return boolean
	 */
	public function fetch()

	/**
	 * A találatban szereplő fajnév
	 * @return string
	 */
	public function getSpeciesName()

	/**
	 * A találatban szereplő kromoszóma
	 * @return integer
	 */
	public function getChromosome()

	/**
	 * A találatban szereplő gén azonosító
	 * @return string
	 */
	public function getGeneId()

	/**
	 * A találatban szereplő külső adatbázis (pl.: HGNC, MGI) neve
	 * @return string
	 */
	public function getExternalDatabaseName()

	/**
	 * A találatban szereplő gén külső adatbázisban található azonosítója
	 * @return string
	 */
	public function getExternalDatabaseId()

	/**
	 * A találatban szereplő szekvencia
	 * @return string
	 */
	public function getSequence()

}
