<?php
class Bio_Entrez_eSearch
{
	/**
	 * Az Entrez eSearch szolgáltatásának elérési útvonala
	 * @var string
	 */
	private static $eSearchURL = 'http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?';

	/**
	 * A keresendő adatbázis neve (pl.: 'nuccore')
	 * @var string
	 */
	private $database;

	/**
	 * A kereső kifejezés
	 * @var string
	 */
	private $keyword;

	/**
	 * A keresés eredményeként kapott találatok száma
	 * @var integer
	 */
	private $resultCount;

	/**
	 * A keresés eredményeként kapott találatok azonosítóit tartalmazó tömb
	 * @var array
	 */
	private $results;

	/**
	 * @param string $keyword
	 * @param string $database
	 */
	public function __construct($keyword, $database)

	/**
	 * A keresést végrehajtó metódus
	 * @return boolean A keresés eredményeként kapott találatok száma, amennyiben nagyobb, mint nulla, a visszatérési érték true, egyébként false
	 */
	public function search()

	/**
	 * A keresés eredményeként kapott találatok számát visszaadó eljárás
	 * @return integer
	 */
	public function getResultCount()

	/**
	 * A keresés eredményeként kapott találatok azonosítóit tartalmazó tömböt visszaadó eljárás
	 * @return array
	 */
	public function getResultIDs()

}
