<?PHP
class Bio_EntrezGene
{
	private static $eFetchURL 	= 'http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?';
	private static $eSearchURL  = 'http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?';
	private $database 			= 'gene';

	private $results;

	public function __construct()
	{
		$this->results = array();
	}

	protected function search($term)
	{
		$this->results = array();
		$URL    = self::$eSearchURL . 'db=' . $this->database . '&term=' . $term;
		$socket = Socket::getInstance();
		$socket->doHTTPGet($URL);
		$xmlText= $socket->getHTTPBody();
		if(strlen($xmlText) > 0) {
			$xml = new SimpleXMLElement($xmlText);
			foreach($xml->IdList->Id as $id) {
				$this->results[] = $id;
			}
		}
	}

	protected function getOrganism($id)
	{
		$URL     = self::$eFetchURL . 'db=' . $this->database . '&retmode=xml&id=' . $id;
		$socket  = Socket::getInstance();
		$socket->doHTTPGet($URL);
		$xmlText = $socket->getHTTPBody();
		if(strlen($xmlText) > 0) {
			//var_dump($xmlText);
			$xml      = new SimpleXMLElement($xmlText);
			$orgref   = 'Org-ref';
			$taxname  = 'Org-ref_taxname';
			$organism = (string)$xml->Entrezgene->Entrezgene_source->BioSource->BioSource_org->$orgref->$taxname;
			return $organism;
		}
	}

	public function getEntrezId($gene, $taxname)
	{
		$this->search($gene);
		if(count($this->results) > 0) {
			foreach($this->results as $result) {
				if($taxname == $this->getOrganism($result)) {
					return $result;
				}
			}
		}
		return false;
	}

}
