<?PHP
class Database_ResultSet {
	
	private $fetchmode;
	private $result;
	private $cursorPosition = 0;
	private $row;
	
	
	public function __construct($result, $fetchmode = null) {
		$this->result     = $result;
		if($fetchmode !== null) {
			$this->fetchmode = $fetchmode;
		} else {
			$this->fetchmode = MYSQLI_ASSOC;
		}
	}
	
	public function __destruct() {
		@mysqli_free_result($this->result);
	}
	
	public function seek($rowNumber) {
		if (!@mysqli_data_seek($this->result, $rowNumber)) {
			return false;
		}
		$this->cursorPos = $rowNumber;
		return true;
	}
	
	public function next() {
		$this->row = mysqli_fetch_array($this->result, $this->fetchmode);
		$resource  = DB::getResource();
		if(!$this->row) {
			$error = mysqli_errno($resource);
			if(!$error) {
				return false;
			} else {
				throw new DatabaseException('Error fetching result', mysqli_error($resource));
			}
		}
		$this->cursorPosition++;
		return $this->row;
	} 
	
	public function getRecordCount() {
		$rows = @mysqli_num_rows($this->result);
		if ($rows === null) {
			throw new DatabaseException("Error fetching number of rows", mysqli_error($this->connection->getResource()));
		}
		return (int)$rows;
	}
	
}
