<?PHP
class DatabaseException extends Exception {
	protected $userInfo;
	protected $nativeError;
	
	public function __construct($msg, $native = null, $userinfo = null) {
		parent::__construct($msg);
		if ($native !== null) {
			$this->setNativeError($native);
		}
		if ($userinfo !== null) {
			$this->setUserInfo($userinfo);
		}
	}
	
	public function setUserInfo($info) {
		$this->userInfo = $info;
		$this->message .= " [User Info: " . $this->userInfo . "]";
	}
	
	public function getUserInfo() {
		return $this->userInfo;
	}
	
	public function setNativeError($native) {
		$this->nativeError = $native;
		$this->message .= " [User Info: " . $this->nativeError . "]";
	}
	
	public function getNativeError() {
		return $this->nativeError;
	}	
	
	public function toString() {
		return $this->getMessage();
	}
	
	
}