<?PHP
$query = new Bio_BioMartQuery($_keyword);
$query->setDataset("hsapiens_gene_ensembl");
$query->addFilter("status", "KNOWN");
$query->addAttribute("chromosome_name");
$query->addAttribute("external_gene_id");
$query->addAttribute("mouse_chromosome");
$query->addAttribute("mouse_external_id");
$query->addAttribute("mouse_ensembl_gene");

$genes  = array();
$sql 	= "SELECT gene FROM entrez_fetch WHERE search_id='1' AND organism_id='1'";
$result = DB::executeQuery($sql);
while(($row = $result->next()) != false) {
	$genes[] = $row['gene'];
}
$genes	= join(',', $genes);
$query->addFilter("hgnc", $genes);

// execute
$response = '';
$response = $query->execute();

if(strlen($response) > 0) {
	$j = 0;
	$response = explode("\n", $response);
	foreach($response as $record) {
		$record = explode("\t", $record);
		// valid record
		if((strlen($record[2]) > 0) && (strlen($record[3]) > 0)) {
			# $record[0] - source chromosome
			# $record[1] - source gene ID
			# $record[2] - target chromosome
			# $record[3] - target gene ID
			# $record[4] - target gene Ensembl ID
			if($record[2] == 'NT_166323') {
				$record[2] = 1;
			}
			// test whether it exists or not
			$query 	= "SELECT id FROM biomart_homologs WHERE (search_id='1') AND (organism_id='1') AND "
					. "(chromosome='" . $record[0] . "') AND (LOWER(gene)='" . strtolower($record[1]) . "') AND "
					. "(target_organism_id='2') AND (homolog_chromosome='" . $record[2] . "') AND "
					. "(LOWER(homolog_gene)='" . strtolower($record[3]) . "')";
			$result = DB::executeQuery($query);
			if($result->getRecordCount() == 0) {
				$query 	= "INSERT INTO biomart_homologs (search_id, organism_id, chromosome, gene, target_organism_id, "
						. "homolog_chromosome, homolog_gene, homolog_ensembl_id) VALUES ('1', '1', '" . $record[0] . "', "
						. "'" . $record[1] . "', '2', '" . $record[2] . "', '" . $record[3] . "', '" . $record[4] . "')";
				DB::executeInsert($query);
				$j++;
			}
		}
	}
	Log::screenLog("Results parsed, " . $j . " new homologs inserted.");
} else {
	Log::screenLog("Empty response from the Biomart server.");
}
