<?PHP
$genes  = array();
$query  = "SELECT db_xref FROM results WHERE (search_id='1') AND (organism_id='2') AND (db_xref IS NOT NULL)";
$result = DB::executeQuery($query);
while(($row = $result->next()) != false) {
	$genes[] = $row['db_xref'];
}

$query = new Bio_BioMartQuery($_keyword);
$query->setDataset("mmusculus_gene_ensembl");
$query->addFilter("entrezgene", join(',', $genes));
$query->addAttribute("chromosome_name");
$query->addAttribute("external_gene_id");
$query->addAttribute("human_chromosome");
$query->addAttribute("human_external_id");
$query->addAttribute("human_external_db");

// execute
$response = '';
$response = $query->execute();

if(strlen($response) > 0) {
	$j = 0;
	$response = explode("\n", $response);
	foreach($response as $record) {
		$record = explode("\t", $record);
		// valid record
		if((strlen($record[2]) > 0) && (strlen($record[3]) > 0)) {
			# $record[0] - source chromosome
			# $record[1] - source gene ID
			# $record[2] - target chromosome
			# $record[3] - target gene ID
			# $record[4] - target database name
			$query	= "UPDATE results SET homolog_organism_id='1', homolog_chromosome='" . $record[2] . "', "
					. "  homolog_gene='" . $record[3] . "', homolog_db_name='" . $record[4] . "' "
					. "WHERE (search_id='1') AND (organism_id='2') AND (chromosome='" . $record[0] . "') AND "
					. "  (LOWER(gene)='" . strtolower($record[1]) . "')";
			DB::executeUpdate($query);
			$j++;
		}
	}
	Log::screenLog("Results parsed, " . $j . " new homologs inserted.");
} else {
	Log::screenLog("Empty response from the Biomart server.");
}
