<?php
class Bio_NCBI_Blast
{
	/**
	 * Az NCBI Blast szolgáltatásának elérési útvonala
	 * @var string
	 */
	private static $blastURL = 'http://www.ncbi.nlm.nih.gov/blast/Blast.cgi';

	private $program;

	private $url;

	private $return;

	private $results;

	/**
	 * @param string $sequence A keresendő szekvencia
	 * @param string $program A BLAST program (megablast, blastn, blastp, rpsblast, blastx, tblastn, tblastx)
	 * @param string $database A keresendő adatbázis (pl.: 'nuccore')
	 */
	public function __construct($sequence, $program, $database)

	/**
	 * A megadott szekvenciát FASTA formátumba konvertálja
	 * @param string $sequence
	 * @return string
	 */
	private function sequence2Fasta($sequence)

	/**
	 * A kereséshez paramért rendel hozzá (például: Elvárt érték)
	 * @param string $key
	 * @param string $value
	 * @return void
	 */
	public function addParameter($key, $value)

	/**
	 * A kiválasztott program és paraméterek alapján összeállítja a lekérdezés URL-jét
	 * @return string
	 */
	private function createSearchURL()

	/**
	 * Végrehajtja a keresést
	 * @return void
	 */
	public function search()

	/**
	 * Tájékoztat a keresés végeredményéről
	 * 0 - sikeres keresés
	 * 1 - érvénytlen paraméterek
	 * 2 - nincs szignifikáns találat
	 * 3 - a keresés azonosító (RID) lejárt
	 * 4 - a keresés meghiúsult
	 * 5 - ismeretlen hiba
	 * @return integer
	 */
	public function getReturnCode()

	/**
	 * A keresés eredményét adja vissza
	 * @return string
	 */
	public function getResults()

}
